unit AVARJ;
interface
 uses Dos, objects, ArcView;
 Type
          TAFHeader = Record
                       HeadId  : Word;                         { 60000 }
                       BHdrSz  : Word;             { Basic Header Size }
                       FHdrSz  : Byte;              { File Header Size }
                       AVNo    : Byte;
                       MAVX    : Byte;
                       HostOS  : Byte;
                       Flags   : Byte;
                       SVer    : Byte;
                       FType   : Byte;    { must be 2 for basic header }
                       Res1    : Byte;
                       DOS_DT  : LongInt;
                       CSize   : LongInt;            { Compressed Size }
                       OSize   : LongInt;            { Original Size }
                       SEFP    : LongInt;
                       FSFPos  : Word;
                       SEDLgn  : Word;
                       Res2    : Word;
                     end;

     PARJArchive=^TARJArchive;
     TARJArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  private
                   Header:TAFHeader;
                   Name:String;
                   Procedure GetHeader;
                 end;
implementation
 Constructor TARJArchive.Init;
 begin
  Inherited Init(AFile);
  GetHeader;{Read record with archive name}
  GetHeader;{Read First file record}
 end;
 Function TARJArchive.FindNext(var Sr:TArcRec):boolean;
 begin
  if Name='' then FindNext:=False
   else
    begin
     Sr.Name:=Name;
     Sr.Attr:=Header.Flags;
     Sr.Size:=Header.OSize;
     Sr.PackedSize:=Header.CSize;
     Sr.Time:=Header.Dos_DT;
     FindNext:=True;
     GetHeader;
   end;
 end;
Procedure TArjArchive.GetHeader;
var NewPos:LongInt;Ch:Char;
begin
 Name:='';
 NewPos:=F^.GetPos;
 if NewPos<0 then
  begin
   exit;
  end;
 F^.Read(Header,SizeOf(Header));
 if Header.HeadID<>60000 then exit;
 if Header.BHdrSZ>0 then
  begin
   Ch:=#0;
   Repeat
    F^.Read(Ch,1);
    if ch<>#0 then Name:=Name+ch;
   until (ch=#0)or(F^.Status<>0);
  end;
  Inc(NewPos,10);
  Inc(NewPos,Header.BHDrSz);
  if Header.FType<>2 then Inc(NewPos,Header.CSize);
  F^.seek(NewPos);
end;
end.
