unit AVbsa;
interface
 uses Dos, objects, ArcView;
 Type TBFHeader = record
                   Signature:Longint;
                   PackedSize:LongInt;
                   Size:LongInt;
                   Time:Longint;
                   Crc:LongInt;
                   Attr:Word;
                   Name:PathStr;
                  end;
     PBSAArchive=^TBSAArchive;
     TBSAArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  private
                  Header:TBFHeader;
                  Procedure GetHeader;
                 end;
  Function CheckBSAMarker(var Buff):Boolean;
implementation
 Constructor TBSAArchive.Init;
 begin
  Inherited Init(AFile);
  GetHeader;
  if not CheckBsaMarker(Header) then
   begin
    Dispose(f,Done);
    Fail;
   end;
 end;

 Function TBSAArchive.FindNext(var Sr:TArcRec):boolean;
 var I:Integer;
 begin
  if Header.Name<>'' then
  With Header do
   begin
    FindNext:=True;
    Sr.Name[0]:=Name[0];
    For i:=1 to Length(Name)do
     if Name[i]='/' then Sr.Name[i]:='\' else
    Sr.Name[i]:=Upcase(Name[i]);
    Sr.Attr:=Attr and $3F;
    Sr.Time:=Time;
    Sr.Size:=Size;
    Sr.PackedSize:=PackedSize;
    GetHeader;
   end
  else FindNext:=False;
 end;

 Procedure TBSAArchive.GetHeader;
 begin
  F^.Read(Header,SizeOf(TBFHeader));
  if F^.Status<>0 then
   begin
    Header.Name:='';
    exit;
   end;
  F^.Seek(F^.GetPos+Header.PackedSize-(SizeOf(PathStr)-1)+Length(Header.Name)+1);
 end;
 Function CheckBsaMarker(var Buff):Boolean;
 var a:Longint absolute Buff;
 begin
  CheckBsaMarker:=A=$7AE0021
 end;
end.
